diff --git a/game/core/src/main/java/net/minecraft/core/item/Items.java b/game/core/src/main/java/net/minecraft/core/item/Items.java
index a9a2f7b42..895ae1556 100644
--- a/game/core/src/main/java/net/minecraft/core/item/Items.java
+++ b/game/core/src/main/java/net/minecraft/core/item/Items.java
@@ -60,6 +60,13 @@ public final class Items {
     public static Item WHEAT;
     public static Item FOOD_BREAD;
 
+    public static Item BUCKET_IRON;
+    public static Item BUCKET_STEEL;
+    //public static Item BUCKET_WATER;
+    //public static Item BUCKET_LAVA;
+    //public static Item BUCKET_MILK;
+    //public static Item BUCKET_ICECREAM;
+
     public static Item ARMOR_HELMET_LEATHER;
     public static Item ARMOR_CHESTPLATE_LEATHER;
     public static Item ARMOR_LEGGINGS_LEATHER;
@@ -94,9 +101,6 @@ public final class Items {
     public static Item FOOD_APPLE_GOLD;
     public static Item SIGN;
     public static Item DOOR_OAK;
-    public static Item BUCKET;
-    public static Item BUCKET_WATER;
-    public static Item BUCKET_LAVA;
     public static Item MINECART;
     public static Item SADDLE;
     public static Item DOOR_IRON;
@@ -104,7 +108,6 @@ public final class Items {
     public static Item AMMO_SNOWBALL;
     public static Item BOAT;
     public static Item LEATHER;
-    public static Item BUCKET_MILK;
     public static Item BRICK_CLAY;
     public static Item CLAY;
     public static Item SUGARCANE;
@@ -171,7 +174,6 @@ public final class Items {
     public static Item OLIVINE;
     public static Item AMMO_PEBBLE;
     public static Item FOOD_CHERRY;
-    public static Item BUCKET_ICECREAM;
     public static Item AMMO_ARROW_PURPLE;
     public static Item LABEL;
     public static Item JAR;
@@ -326,9 +328,9 @@ public final class Items {
         FOOD_APPLE_GOLD = (new ItemFood("food.apple.gold", "minecraft:item/food_apple_gold", 16450, 42, 0, false, 1));
         SIGN = (new ItemSign("sign", "minecraft:item/sign", 16451));
         DOOR_OAK = (new ItemDoor("door.oak", "minecraft:item/door_oak", 16452, Blocks.DOOR_PLANKS_OAK_BOTTOM, Blocks.DOOR_PLANKS_OAK_TOP));
-        BUCKET = (new ItemBucketEmpty("bucket", "minecraft:item/bucket", 16453));
-        BUCKET_WATER = (new ItemBucket("bucket.water", "minecraft:item/bucket_water", 16454, Blocks.FLUID_WATER_FLOWING)).setContainerItem(BUCKET);
-        BUCKET_LAVA = (new ItemBucket("bucket.lava", "minecraft:item/bucket_lava", 16455, Blocks.FLUID_LAVA_FLOWING)).setContainerItem(BUCKET);
+        //16453 DO NOT TOUCH THIS ID, LEGACY BUCKET CONVERTS FROM IT
+        //16454 DO NOT TOUCH THIS ID, LEGACY BUCKET CONVERTS FROM IT
+        //16455 DO NOT TOUCH THIS ID, LEGACY BUCKET CONVERTS FROM IT
         MINECART = (new ItemMinecart("minecart", "minecraft:item/minecart", 16456, EntityMinecart.PASSENGER_CART));
         SADDLE = (new ItemSaddle("saddle", "minecraft:item/saddle", 16457));
         DOOR_IRON = (new ItemDoor("door.iron", "minecraft:item/door_iron", 16458, Blocks.DOOR_IRON_BOTTOM, Blocks.DOOR_IRON_TOP));
@@ -336,7 +338,7 @@ public final class Items {
         AMMO_SNOWBALL = (new ItemSnowball("ammo.snowball", "minecraft:item/ammo_snowball", 16460));
         BOAT = (new ItemBoat("boat", "minecraft:item/boat", 16461));
         LEATHER = (new Item("leather", "minecraft:item/leather", 16462));
-        BUCKET_MILK = (new ItemBucket("bucket.milk", "minecraft:item/bucket_milk", 16463, null)).setContainerItem(BUCKET);
+        //16463 DO NOT TOUCH THIS ID, LEGACY BUCKET CONVERTS FROM IT
         BRICK_CLAY = (new Item("brick.clay", "minecraft:item/brick_clay", 16464));
         CLAY = (new Item("clay", "minecraft:item/clay", 16465));
         SUGARCANE = (new ItemPlaceable("sugarcane", "minecraft:item/sugarcane", 16466, Blocks.SUGARCANE));
@@ -403,7 +405,7 @@ public final class Items {
         OLIVINE = (new Item("olivine", "minecraft:item/olivine", 16513));
         AMMO_PEBBLE = (new ItemPebble("ammo.pebble", "minecraft:item/ammo_pebble", 16514));
         FOOD_CHERRY = (new ItemFood("food.cherry", "minecraft:item/food_cherry", 16515, 2, 2, false, 2));
-        BUCKET_ICECREAM = (new ItemBucketIceCream("bucket.icecream", "minecraft:item/bucket_icecream", 16516, 10, 4)).setContainerItem(BUCKET);
+        //16516 DO NOT TOUCH THIS ID, LEGACY BUCKET CONVERTS FROM IT
         AMMO_ARROW_PURPLE = (new Item("ammo.arrow.purple", "minecraft:item/ammo_arrow_purple", 16517)).withTags(ItemTags.NOT_IN_CREATIVE_MENU);
         LABEL = (new ItemLabel("label", "minecraft:item/label", 16518));
         JAR = (new ItemJar("jar", "minecraft:item/jar", 16519));
@@ -450,5 +452,8 @@ public final class Items {
         ARMOR_WOLF_DIAMOND = new ItemArmor<>("armor.wolf.diamond", "minecraft:item/armor_wolf_diamond", 16559, ArmorMaterial.DIAMOND, WolfArmorShape.BODY);
         ARMOR_WOLF_GOLD = new ItemArmor<>("armor.wolf.gold", "minecraft:item/armor_wolf_gold", 16560, ArmorMaterial.GOLD, WolfArmorShape.BODY);
         ARMOR_WOLF_STEEL = new ItemArmor<>("armor.wolf.steel", "minecraft:item/armor_wolf_steel", 16561, ArmorMaterial.STEEL, WolfArmorShape.BODY);
+
+        BUCKET_IRON = (new ItemBucketIron("bucket.iron", "minecraft:item/bucket_iron", 16562));
+        BUCKET_STEEL = (new ItemBucketSteel("bucket.steel", "minecraft:item/bucket_steel", 16563));
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
index 67c963377..a721eea58 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
@@ -3,15 +3,13 @@ package net.minecraft.core.player.inventory.menu;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.IPainted;
 import net.minecraft.core.block.tag.BlockTags;
-import net.minecraft.core.item.ItemCoal;
+import net.minecraft.core.item.*;
 import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.lang.I18n;
-import net.minecraft.core.item.Item;
-import net.minecraft.core.item.Items;
-import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.player.inventory.container.ContainerInventory;
 import net.minecraft.core.player.inventory.slot.SlotCreative;
+import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.DyeColor;
 
 import java.util.ArrayList;
@@ -156,6 +154,16 @@ public class MenuInventoryCreative extends MenuInventory
 				for (DyeColor color : DyeColor.values()) {
 					creativeItems.add(new ItemStack(item, 1, color.itemMeta));
 				}
+           } else if (item instanceof ItemBucket bucket) {
+				creativeItems.add(new ItemStack(item));
+				for (NamespaceID stateId : ItemBucket.getRegisteredStateIds()) {
+					if (ItemBucket.STATE_EMPTY.equals(stateId)) continue;
+					ItemStack itemStack = new ItemStack(item, 1);
+					ItemBucket.setState(itemStack, stateId);
+					ItemBucket.setCharges(itemStack, bucket.maxCharges);
+
+					creativeItems.add(itemStack);
+				}
 			} else {
 				creativeItems.add(new ItemStack(item));
 			}
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/slot/SlotResult.java b/game/core/src/main/java/net/minecraft/core/player/inventory/slot/SlotResult.java
index cd181212d..2b7fabb42 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/slot/SlotResult.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/slot/SlotResult.java
@@ -4,9 +4,7 @@ import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.item.Item;
-import net.minecraft.core.item.Items;
-import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.*;
 import net.minecraft.core.item.tool.ItemToolHoe;
 import net.minecraft.core.item.tool.ItemToolPickaxe;
 import net.minecraft.core.item.tool.ItemToolSword;
@@ -41,7 +39,7 @@ public class SlotResult extends Slot
 		if(item.id == Blocks.FURNACE_STONE_IDLE.id()) thePlayer.addStat(Achievements.BUILD_FURNACE, 1);
 		if(item.id == Items.FOOD_BREAD.id) thePlayer.addStat(Achievements.MAKE_BREAD, 1);
 		if(item.id == Items.FOOD_CAKE.id) thePlayer.addStat(Achievements.BAKE_CAKE, 1);
-		if(item.id == Items.BUCKET_ICECREAM.id) thePlayer.addStat(Achievements.CRAFT_ICECREAM, 1);
+		if(item instanceof ItemBucket && ItemBucket.getState(itemStack) == ItemBucket.STATE_ICECREAM) thePlayer.addStat(Achievements.CRAFT_ICECREAM, 1);
 		if(item.id == Items.FOOD_PUMPKIN_PIE.id) thePlayer.addStat(Achievements.CRAFT_PUMPKIN_PIE, 1);
 		if(item.id == Items.HANDCANNON_UNLOADED.id) thePlayer.addStat(Achievements.CRAFT_HANDCANNON, 1);
 		if(item instanceof ItemToolHoe) thePlayer.addStat(Achievements.BUILD_HOE, 1);
diff --git a/game/core/src/main/java/net/minecraft/core/world/LevelListener.java b/game/core/src/main/java/net/minecraft/core/world/LevelListener.java
index 80eeaa56b..9312da9e5 100644
--- a/game/core/src/main/java/net/minecraft/core/world/LevelListener.java
+++ b/game/core/src/main/java/net/minecraft/core/world/LevelListener.java
@@ -48,6 +48,20 @@ public interface LevelListener
      * data: unused
      */
     int EVENT_PISTON_RETRACT = 1007;
+    /**
+     * data: is a packed byte containing a {@link net.minecraft.core.util.helper.Side} and a conduit signal strength (0-10) <div></div>
+     * Bits 0-3: Signal Strength (Value: 0-10) <div>
+     * Bits 4-6: Side ID (Value: 0-5, or 7 for NONE) <div>
+     * Bit 7: Unused (Reserved) <div></div>
+     */
+    int EVENT_CONDUIT_PORT_PARTICLES = 1008;
+    /**
+     * data: is a packed byte containing a {@link net.minecraft.core.util.helper.Side} and a conduit signal strength (0-10) <div></div>
+     * Bits 0-3: Signal Strength (Value: 0-10) <div>
+     * Bits 4-6: Side ID (Value: 0-5, or 7 for NONE) <div>
+     * Bit 7: Unused (Reserved) <div></div>
+     */
+    int EVENT_CONDUIT_SURFACE_PARTICLES = 1009;
 
 	/**
 	 * Redraw block in singleplayer and send block change packet in multiplayer. <br>
diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index abd382df0..97881ef47 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -12,6 +12,7 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.current.conduit.ConduitHandler;
 import net.minecraft.core.current.wire.WireHandler;
 import net.minecraft.core.data.gamerule.GameRule;
 import net.minecraft.core.data.gamerule.GameRules;
@@ -147,6 +148,7 @@ public abstract class World implements MutableWorldSource {
     private final @NotNull WeatherManager weatherManager;
     private final @NotNull CommandManager commandManager = new CommandManager(isServer);
     private final @NotNull WireHandler wireHandler = new WireHandler(this);
+    private final @NotNull ConduitHandler conduitHandler = new ConduitHandler(this);
     private final @NotNull LightingEngine lightingEngine = new LightingEngineLegacy(this);
 
     private World(
@@ -304,6 +306,10 @@ public abstract class World implements MutableWorldSource {
         return this.wireHandler;
     }
 
+    public @NotNull ConduitHandler getConduitHandler() {
+        return this.conduitHandler;
+    }
+
     protected abstract @NotNull ChunkProvider createChunkProvider(@NotNull LevelStorage levelStorage); /* {
         final ChunkLoader chunkLoader = this.levelStorage.getChunkLoader(this.dimension);
         return accessor.createChunkProvider(this, chunkLoader);
@@ -2026,6 +2032,7 @@ public abstract class World implements MutableWorldSource {
         if (this.getGameRuleValue(GameRules.DO_DAY_CYCLE)) {
             this.levelData.setWorldTime(this.levelData.getWorldTime() + 1L);
         }
+        this.levelData.setTotalWorldTime(this.levelData.getTotalWorldTime() + 1L);
 
         this.runtime++;
 
@@ -2593,6 +2600,10 @@ public abstract class World implements MutableWorldSource {
         return this.levelData.getWorldTime();
     }
 
+    public long getTotalWorldTime() {
+        return this.levelData.getTotalWorldTime();
+    }
+
     public Difficulty getDifficulty() {
         return this.levelData.getDifficulty();
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkDecoratorSkyblock.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkDecoratorSkyblock.java
index 8ebb9d387..22f1bdc6b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkDecoratorSkyblock.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkDecoratorSkyblock.java
@@ -3,6 +3,7 @@ package net.minecraft.core.world.generate.chunk.skyblock;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityChest;
+import net.minecraft.core.item.ItemBucket;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.world.chunk.Chunk;
@@ -24,7 +25,7 @@ public class ChunkDecoratorSkyblock
             chunk.setBlockIDWithMetadata(4 & (Chunk.CHUNK_SIZE_X - 1), 67, -3 & (Chunk.CHUNK_SIZE_Z - 1), Blocks.CHEST_PLANKS_OAK.id(), 3);
             TileEntity tileEntity = chunk.getTileEntity(4 & (Chunk.CHUNK_SIZE_X - 1), 67, -3 & (Chunk.CHUNK_SIZE_Z - 1));
             if (tileEntity instanceof TileEntityChest chest) {
-                chest.setItem(0, new ItemStack(Items.BUCKET_LAVA, 1));
+                chest.setItem(0, ItemBucket.createItemStack(Items.BUCKET_IRON, ItemBucket.STATE_LAVA, 1));
                 chest.setItem(1, new ItemStack(Blocks.ICE, 1));
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDungeon.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDungeon.java
index 3e7b5eeac..326a5a857 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDungeon.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDungeon.java
@@ -35,7 +35,7 @@ public class WorldFeatureDungeon extends WorldFeature {
         this.chestLoot.addEntry(new WeightedRandomLootObject(Items.WHEAT.getDefaultStack(), 1, 4), 100);
         this.chestLoot.addEntry(new WeightedRandomLootObject(Items.GUNPOWDER.getDefaultStack(), 1, 4), 100);
         this.chestLoot.addEntry(new WeightedRandomLootObject(Items.STRING.getDefaultStack(), 1, 4), 100);
-        this.chestLoot.addEntry(new WeightedRandomLootObject(Items.BUCKET.getDefaultStack()), 100);
+        this.chestLoot.addEntry(new WeightedRandomLootObject(Items.BUCKET_IRON.getDefaultStack()), 100);
         this.chestLoot.addEntry(new WeightedRandomLootObject(Items.FOOD_APPLE_GOLD.getDefaultStack()), 1);
         this.chestLoot.addEntry(new WeightedRandomLootObject(Items.DUST_REDSTONE.getDefaultStack(), 1, 4), 50);
         for (int i = 0; i < 9; i++) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/LevelData.java b/game/core/src/main/java/net/minecraft/core/world/save/LevelData.java
index 76247fd7c..cbc14fe5c 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/LevelData.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/LevelData.java
@@ -53,6 +53,11 @@ public class LevelData {
             tag.getInteger("SpawnZ")
         );
         data.worldTime = tag.getLong("Time");
+        if (tag.containsKey("TotalTime")) {
+            data.totalWorldTime = tag.getLong("TotalTime");
+        } else {
+            data.totalWorldTime = data.worldTime;
+        }
         data.lastTimePlayed = tag.getLong("LastPlayed");
         data.sizeOnDisk = tag.getLong("SizeOnDisk");
         data.saveVersion = tag.getInteger("version");
@@ -77,6 +82,7 @@ public class LevelData {
         out.putInt("SpawnY", levelData.spawnPos.y);
         out.putInt("SpawnZ", levelData.spawnPos.z);
         out.putLong("Time", levelData.worldTime);
+        out.putLong("TotalTime", levelData.totalWorldTime);
         out.putLong("SizeOnDisk", levelData.sizeOnDisk);
         out.putLong("LastPlayed", System.currentTimeMillis());
         out.putString("LevelName", levelData.levelName);
@@ -132,6 +138,7 @@ public class LevelData {
     private final @NotNull SpawnerConfig spawnerConfig;
 
     private long worldTime;
+    private long totalWorldTime;
     private long lastTimePlayed;
     private long sizeOnDisk;
     private @Nullable UUID lastPlayerUUID;
@@ -183,6 +190,7 @@ public class LevelData {
 
         this.spawnPos.set(levelData.spawnPos);
         this.worldTime = levelData.worldTime;
+        this.totalWorldTime = levelData.totalWorldTime;
         this.lastTimePlayed = levelData.lastTimePlayed;
         this.sizeOnDisk = levelData.sizeOnDisk;
         this.playerTag = levelData.playerTag;
@@ -214,6 +222,14 @@ public class LevelData {
         this.worldTime = time;
     }
 
+    public long getTotalWorldTime() {
+        return this.totalWorldTime;
+    }
+
+    public void setTotalWorldTime(final long time) {
+        this.totalWorldTime = time;
+    }
+
     public long getSizeOnDisk() {
         return this.sizeOnDisk;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/conversion/ItemConverters.java b/game/core/src/main/java/net/minecraft/core/world/save/conversion/ItemConverters.java
new file mode 100644
index 000000000..b419ad579
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/save/conversion/ItemConverters.java
@@ -0,0 +1,44 @@
+package net.minecraft.core.world.save.conversion;
+
+import com.mojang.nbt.tags.CompoundTag;
+import net.minecraft.core.item.ItemBucket;
+import net.minecraft.core.util.collection.NamespaceID;
+
+public class ItemConverters {
+    /**
+     * Migrates legacy bucket IDs to the new NBT-based Bucket system.
+     */
+    public static void legacyBucketConverter(CompoundTag tag) {
+        short id = tag.getShort("id");
+        NamespaceID newState = null;
+
+        short ironBucketId = 16562;
+
+        if (id == 16453) {
+            tag.putShort("id", ironBucketId);
+        }
+        else if (id == 16454) { // Legacy Water
+            tag.putShort("id", ironBucketId);
+            newState = ItemBucket.STATE_WATER;
+        }
+        else if (id == 16455) { // Legacy Lava
+            tag.putShort("id", ironBucketId);
+            newState = ItemBucket.STATE_LAVA;
+        }
+        else if (id == 16463) { // Legacy Milk
+            tag.putShort("id", ironBucketId);
+            newState = ItemBucket.STATE_MILK;
+        }
+        else if (id == 16516) { // Legacy Ice Cream
+            tag.putShort("id", ironBucketId);
+            newState = ItemBucket.STATE_ICECREAM;
+        }
+
+        if (newState != null) {
+            CompoundTag dataTag = tag.containsKey("Data") ? tag.getCompound("Data") : new CompoundTag();
+            dataTag.putString("State", newState.toString());
+            dataTag.putInt("Charges", 1);
+            tag.putCompound("Data", dataTag);
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/world/weather/WeatherManager.java b/game/core/src/main/java/net/minecraft/core/world/weather/WeatherManager.java
index 12ac246e3..a6f2a4100 100644
--- a/game/core/src/main/java/net/minecraft/core/world/weather/WeatherManager.java
+++ b/game/core/src/main/java/net/minecraft/core/world/weather/WeatherManager.java
@@ -113,8 +113,7 @@ public class WeatherManager {
         } else if (this.nextWeather != null && this.weatherIntensity >= 0.0f) {
             this.weatherIntensity -= 0.002f;
             if (!this.world.isClientSide) {
-                if (this.currentWeather instanceof IPrecipitation) {
-                    final @NotNull IPrecipitation precipitation = (IPrecipitation) this.currentWeather;
+                if (this.currentWeather instanceof @NotNull IPrecipitation precipitation) {
                     if (this.world.dayCanHaveRainbow &&
                         this.world.rainbowTicks <= 0 &&
                         this.weatherIntensity < 0.5f &&
diff --git a/game/core/src/main/resources/assets/minecraft/lang/en_US/item.lang b/game/core/src/main/resources/assets/minecraft/lang/en_US/item.lang
index 739522bf8..1783d0edc 100644
--- a/game/core/src/main/resources/assets/minecraft/lang/en_US/item.lang
+++ b/game/core/src/main/resources/assets/minecraft/lang/en_US/item.lang
@@ -208,12 +208,6 @@ item.sign.painted.white.desc=Mark your land, or write a message.
 
 item.door.oak.name=Wooden Door
 item.door.oak.desc=Every house needs one.
-item.bucket.name=Bucket
-item.bucket.desc=Used to hold various liquids.
-item.bucket.water.name=Water Bucket
-item.bucket.water.desc=A bucket full of the deep blue.
-item.bucket.lava.name=Lava Bucket
-item.bucket.lava.desc=A bucket full of molten rock. Hot!
 item.minecart.name=Minecart
 item.minecart.desc=An iron vehicle for exploring the deep underground.
 item.saddle.name=Saddle
@@ -228,8 +222,6 @@ item.boat.name=Boat
 item.boat.desc=Sail the seven seas!
 item.leather.name=Leather
 item.leather.desc=A flat cow. Can be used to make armor.
-item.bucket.milk.name=Bucket of Milk
-item.bucket.milk.desc=Good for your bones.
 item.brick.clay.name=Clay Brick
 item.brick.clay.desc=Put 4 of these together to create a solid foundation.
 item.clay.name=Clay
@@ -369,8 +361,6 @@ item.ammo.pebble.name=Pebble
 item.ammo.pebble.desc=A chunk of rock found buried in the soil.
 item.food.cherry.name=Cherries
 item.food.cherry.desc=Red berries that come in pairs.
-item.bucket.icecream.name=Bucket of Ice Cream
-item.bucket.icecream.desc=A frosty treat sprinkled with chocolate chips and a cherry!
 item.ammo.fireball.name=Fire Charge
 item.ammo.fireball.desc=Ammo for a hand cannon. Scatters fire over a wide area.
 item.ammo.arrow.purple.name=Purple Arrow
@@ -378,6 +368,28 @@ item.ammo.arrow.purple.desc=How did you get this?!
 item.label.name=Label
 item.label.desc=Allows you to name items and creatures. Can be dyed.
 
+item.bucket.iron.name=Iron Bucket
+item.bucket.iron.desc=Used to hold various liquids.
+item.bucket.iron.water.name=Iron Water Bucket
+item.bucket.iron.water.desc=A bucket full of the deep blue.
+item.bucket.iron.lava.name=Iron Lava Bucket
+item.bucket.iron.lava.desc=A bucket full of molten rock. Hot!
+item.bucket.iron.milk.name=Iron Bucket of Milk
+item.bucket.iron.milk.desc=Good for your bones.
+item.bucket.iron.icecream.name=Iron Bucket of Ice Cream
+item.bucket.iron.icecream.desc=A frosty treat sprinkled with chocolate chips and a cherry!
+
+item.bucket.steel.name=Steel Bucket
+item.bucket.steel.desc=Used to hold various liquid.
+item.bucket.steel.water.name=Steel Water Bucket
+item.bucket.steel.water.desc=A large bucket full of the deep blue.
+item.bucket.steel.lava.name=Steel Lava Bucket
+item.bucket.steel.lava.desc=A large bucket full of molten rock. Hot!
+item.bucket.steel.milk.name=Steel Bucket of Milk
+item.bucket.steel.milk.desc=Excessively good for your bones!
+item.bucket.steel.icecream.name=Steel Bucket of Ice Cream
+item.bucket.steel.icecream.desc=Maybe a little too much ice cream...
+
 item.candle.soulwax.name=Soul Wax Candle
 item.candle.soulwax.desc=A waxy brown candle that glows with an unnatural light.
 
diff --git a/game/core/src/main/resources/assets/minecraft/lang/en_US/tile.lang b/game/core/src/main/resources/assets/minecraft/lang/en_US/tile.lang
index 711231fb9..887050e81 100644
--- a/game/core/src/main/resources/assets/minecraft/lang/en_US/tile.lang
+++ b/game/core/src/main/resources/assets/minecraft/lang/en_US/tile.lang
@@ -1442,8 +1442,8 @@ tile.block.rubyglass.desc=A translucent glass-like crystal brimming with energy.
 tile.rubyglass.sprout.name=Rubyglass Bud
 tile.rubyglass.sprout.desc=A small bud of rubyglass, branching out in many directions.
 
-tile.rubyglass.circuit.name=Rubyglass Circuit
-tile.rubyglass.circuit.desc=Netherrack etched with lines of rubyglass. It resonates with latent power.
+tile.rubyglass.conduit.name=Rubyglass Conduit
+tile.rubyglass.conduit.desc=Netherrack etched with lines of rubyglass. It resonates with latent power.
 
 tile.vent.name=Chimney
 tile.vent.desc=A rocky column that emits a stream of smoke.
